
from Tkinter import *
import tkFileDialog

try:
    import cPickle as pickle
except:
    import pickle

weather_names = ["Default"]
weather_colors = [[[100,[125,125,125]]]]

def color_gen(color):
    red = str(hex(color[0])[2:])
    while(len(red) < 2):
        red = "0" + red
    green = str(hex(color[1])[2:])
    while(len(green) < 2):
        green = "0" + green
    blue = str(hex(color[2])[2:])
    while(len(blue) < 2):
        blue = "0" + blue
    #print "#" + red + green + blue
    return "#" + red + green + blue
    
def inv_color_gen(color):
    red = str(hex(255-color[0])[2:])
    while(len(red) < 2):
        red = "0" + red
    green = str(hex(255-color[1])[2:])
    while(len(green) < 2):
        green = "0" + green
    blue = str(hex(255-color[2])[2:])
    while(len(blue) < 2):
        blue = "0" + blue
    return "#" + red + green + blue
    
def export():
    f = tkFileDialog.asksaveasfile(mode = 'w', defaultextension=".c", filetypes =  [('C files', '.c'), ('all files', '.*')])
    if f:
        #f.write("{")
        s = ""
        for type in weather_colors:
            s += "{"
            for color in type:
                s += "{"
                s += str(color[1][0])
                s += ","
                s += str(color[1][1])
                s += ","
                s += str(color[1][2])
                s += ","
                s += str(color[0])
                s += "},"
            s = s[:-1]
            s += "}"
            f.write(s)
            s = ","
            s += " //" + weather_names[weather_colors.index(type)]
            s += "\n"
        #f.write("}")
        f.write(" //" + weather_names[-1])
        
        f.close()
    
class color_app:
    def menu_bar(self, master):
        menubar = Menu(master)

        # create a pulldown menu, and add it to the menu bar
        filemenu = Menu(menubar, tearoff=0)
        filemenu.add_command(label="Open", command=self.open)
        filemenu.add_command(label="Save", command=self.save)
        filemenu.add_command(label="Export", command=export)
        filemenu.add_separator()
        filemenu.add_command(label="Exit", command=master.quit)
        menubar.add_cascade(label="File", menu=filemenu)

        # create more pulldown menus
        #editmenu = Menu(menubar, tearoff=0)
        #editmenu.add_command(label="Cut", command=hello)
        #editmenu.add_command(label="Copy", command=hello)
        #editmenu.add_command(label="Paste", command=hello)
        #menubar.add_cascade(label="Edit", menu=editmenu)

        helpmenu = Menu(menubar, tearoff=0)
        helpmenu.add_command(label="About", command=None)
        menubar.add_cascade(label="Help", menu=helpmenu)

        # display the menu
        master.config(menu=menubar)
        
    def open(self):
        f = tkFileDialog.askopenfile(mode = 'r', filetypes =  [('WIc files', '.wic'), ('all files', '.*')])
        if f:
            data = pickle.load(f)
            f.close()
            
            del weather_names[:]
            weather_names.extend(data[0])
            del weather_colors[:]
            weather_colors.extend(data[1])
            
            print weather_names
            print weather_colors
            
            self.update()
        
    def save(self):
        f = tkFileDialog.asksaveasfile(mode = 'w', defaultextension=".wic", filetypes =  [('WIc files', '.wic'), ('all files', '.*')])
        if f:
            pickle.dump([weather_names, weather_colors], f)
            f.close()
            
            self.update
        
        
    def __init__(self, master):
        self.root = master
        self.root.title("WiColGen")
        self.step = [0,0]
        
        self.menu_bar(master)

        frame = Frame(master)
        frame.pack()
        
        left_frame = Frame(frame)
        left_frame.pack(side=LEFT, fill = BOTH)

        middle_frame = Frame(frame)
        middle_frame.pack(side=LEFT, fill = BOTH)
        
        right_frame = Frame(frame)
        right_frame.pack(side=RIGHT, fill = BOTH)
        
        self.list_label = Label(left_frame, text="Type:")
        self.list_label.pack(side=TOP)
        
        w_frame = Frame(left_frame)
        w_frame.pack(side=TOP, expand = 1)
        
        self.w_scrollbar = Scrollbar(w_frame)
        self.w_scrollbar.pack(side=RIGHT, fill=Y)
        
        self.weather_list = Listbox(w_frame, exportselection=0, yscrollcommand=self.w_scrollbar.set)
        self.weather_list.pack(side=LEFT, fill=Y)  
        
        self.weather_list.bind('<<ListboxSelect>>', self.weather_select)
        
        self.w_scrollbar.config(command = self.weather_list.yview)
        
        self.remove_type = Button(left_frame, text="Delete", command=self.remove_weather)
        self.remove_type.pack(side=LEFT)

        self.add_type = Button(left_frame, text="Add", command=self.add_weather)
        self.add_type.pack(side=LEFT)
        
        self.copy_type = Button(left_frame, text="Copy", command=self.copy_weather)
        self.copy_type.pack(side=LEFT)
        
        self.type_name = Entry(middle_frame, text="")#, validate=ALL, validatecommand=self.update_name)
        self.type_name.pack(side=TOP)
        self.type_name.bind('<Return>', self.update_name)
        
        
        self.list_label = Label(middle_frame, text="Sequence:")
        self.list_label.pack(side=TOP)
      
        c_frame = Frame(middle_frame)
        c_frame.pack(side=TOP)
        
        self.c_scrollbar = Scrollbar(c_frame)
        self.c_scrollbar.pack(side=RIGHT, fill=Y)
      
        self.color_list = Listbox(c_frame, exportselection = 0, yscrollcommand=self.c_scrollbar.set)
        self.color_list.pack(side=TOP)  
        self.color_list.bind('<<ListboxSelect>>', self.time_select)
        
        self.c_scrollbar.config(command = self.color_list.yview)
        
        self.remove_color = Button(middle_frame, text="Delete", command=self.remove_time)
        self.remove_color.pack(side=LEFT)

        self.add_color = Button(middle_frame, text="Add", command=self.add_time)
        self.add_color.pack(side=LEFT)
        
        self.color_frame = Label(right_frame, bg = "#000000", text="Color")
        self.color_frame.pack(side=TOP, fill=BOTH, expand = 1)
        
        self.red_label = Label(right_frame, text="Red:")
        self.red_label.pack(side=TOP)
        
        self.red_val = Entry(right_frame, text="")
        self.red_val.pack(side=TOP)
        self.red_val.bind('<Return>', self.update_color)
        
        self.green_label = Label(right_frame, text="Green:")
        self.green_label.pack(side=TOP)
        
        self.green_val = Entry(right_frame, text="")
        self.green_val.pack(side=TOP)
        self.green_val.bind('<Return>', self.update_color)
        
        self.blue_label = Label(right_frame, text="Blue:")
        self.blue_label.pack(side=TOP)
        
        self.blue_val = Entry(right_frame, text="")
        self.blue_val.pack(side=TOP)
        self.blue_val.bind('<Return>', self.update_color)
        
        self.duration_label = Label(right_frame, text="Duration:")
        self.duration_label.pack(side=TOP)
        
        self.duration_val = Entry(right_frame, text="")
        self.duration_val.pack(side=TOP)
        self.duration_val.bind('<Return>', self.update_color)
        
        self.update()
        
        self.root.after(1000, self.update_clock)
        

    def add_weather(self):
        #self.weather_list.insert(END, "Weather name")
        weather_names.append("Weather_name")
        weather_colors.append([[100, [125,125,125]]])
        self.update()
        self.reset_step()
        
        
    def remove_weather(self):
        if len(weather_names) > 1:
            i = self.get_i()
            del weather_names[i]
            del weather_colors[i]
            self.update()
        self.reset_step()
        
    def copy_weather(self):
        i = self.get_i()
        weather_names.append(weather_names[i])
        weather_colors.append([])
        for color in weather_colors[i]:
            #print color
            weather_colors[-1].append([color[0],[color[1][0],color[1][1],color[1][2]]])
        self.update()
            
    def weather_select(self, event):
        self.update()
        self.reset_step()
        
    def update_name(self, event):
        i = self.get_i()
        #if(self.type_name.get() != self.weather_list.get(i)):
        #print self.type_name.get(), self.weather_list.get(i)
        weather_names[i] = self.type_name.get()
        self.update()
        
    def add_time(self):
        i = self.get_i()
        j = self.get_j()
        weather_colors[i].insert(j, [100,[125,125,125]])
        self.update()
        
    def remove_time(self):
        i = self.get_i()
        if len(weather_colors[i]) > 1:
            j = self.get_j()
            del weather_colors[i][j]
            self.update()
        self.reset_step()
            
    def time_select(self, event):
        self.update()
        
    def update_color(self, event):
        i = self.get_i()
        j = self.get_j()
        
        try:
            red = int(self.red_val.get())
            red = max(0, min(255, red))
        except:
            red = 0
            
        try:
            green = int(self.green_val.get())
            green = max(0, min(255, green))
        except:
            green = 0
            
        try:
            blue = int(self.blue_val.get())
            blue = max(0, min(255, blue))
        except:
            blue = 0
            
        try:
            dur = int(self.duration_val.get())
            dur = max(0, min(255, dur))
        except:
            dur = 0
            
        weather_colors[i][j][0] = dur
        weather_colors[i][j][1][0] = red
        weather_colors[i][j][1][1] = green
        weather_colors[i][j][1][2] = blue
        
        #print weather_colors
        
        self.update()
        
        
    def get_i(self):
        try:
            return int(self.weather_list.curselection()[0])
        except:
            return 0
            
    def get_j(self):
        try:
            return int(self.color_list.curselection()[0])
        except:
            return 0
        
    def update_weather_list(self):
        i = self.get_i()
        self.weather_list.delete(0, END)
        for name in weather_names:
            self.weather_list.insert(END, name)
            #self.color_list.itemconfig(END, bg = color_gen(color[1]))
            #self.color_list.itemconfig(END, fg = inv_color_gen(color[1]))
        if i > self.weather_list.size():
            self.weather_list.select_anchor(0)
            self.weather_list.select_set(0)
        else:
            self.weather_list.select_anchor(i)
            self.weather_list.select_set(i)
            
        self.weather_list.yview("moveto", float(i)/len(weather_names))
            
        self.type_name.delete(0,END)
        self.type_name.insert(0, weather_names[i])    
        
    def update_color_list(self):
        i = self.get_i()
        j = self.get_j()
        self.color_list.delete(0, END)
        #print weather_colors
        for color in weather_colors[i]:
            #print color
            self.color_list.insert(END, str(color[0]))
            self.color_list.itemconfig(END, bg = color_gen(color[1]))
            self.color_list.itemconfig(END, fg = inv_color_gen(color[1]))
        if(j >= self.color_list.size()):
            self.color_list.select_anchor(0)
            self.color_list.select_set(0)
        else:
            self.color_list.select_anchor(j)
            self.color_list.select_set(j)
            
            
        self.color_list.yview("moveto", float(j)/len(weather_colors[i]))    
        #print weather_colors
         
        self.red_val.delete(0,END)
        self.red_val.insert(0, str(weather_colors[i][j][1][0]))    
        
        self.green_val.delete(0,END)
        self.green_val.insert(0, str(weather_colors[i][j][1][1]))  
        
        self.blue_val.delete(0,END)
        self.blue_val.insert(0, str(weather_colors[i][j][1][2]))  
        
        self.duration_val.delete(0,END)
        self.duration_val.insert(0, str(weather_colors[i][j][0]))  
    
    def update(self):
        self.update_weather_list()
        self.update_color_list()
    
    def get_current_color(self):
        i = self.get_i()

        c1 = weather_colors[i][self.step[0]][1]
        c2 = weather_colors[i][(self.step[0]+1)%len(weather_colors[i])][1]
        dur = weather_colors[i][self.step[0]][0]
        
        color = [0, 0, 0]
        for c in range(len(color)):
            #print c1, c2
            color[c] = c1[c] + int((c2[c] - c1[c])*self.step[1]/dur)
            
        #print c1, c2, dur, self.step
        #print color_gen(color)
        return color_gen(color)
        
    def reset_step(self):
        self.step = [0,0]
            
    def update_step(self):
        i = self.get_i()
        self.step[1] += 2
        if 1:
        #try:
            if(self.step[1] >= weather_colors[i][self.step[0]][0]):
                self.step[1] = 0
                self.step[0] += 1
                if self.step[0] >= len(weather_colors[i]):
                    self.step[0] = 0
        #except:
        #    self.reset_step()
        #    print "ERROR IN STEP, SOMWHERE RESET IS MISSING!"
         
    def update_clock(self):
        self.update_step()
        #print self.step
        self.color_frame.configure(bg=self.get_current_color())
        self.root.after(20, self.update_clock)

root = Tk()

app = color_app(root)

root.mainloop()