//Other files
#include "defines.h"
#include "usart.h"
#include "rtc.h"

#include "cgpio.h"

//extern usart_buffer rn_buffer;

void enable_gpio_clocks(void)
{
	//enable clocks to ports
	RCC->AHBENR |= RCC_AHBENR_GPIOBEN;
	RCC->AHBENR |= RCC_AHBENR_GPIOAEN;
	RCC->AHBENR |= RCC_AHBENR_GPIOCEN;
	//RCC->AHBENR |= RCC_AHBENR_GPIOAEN;
}

void init_gpio(void)
{
	//PIN C 13 - STATUS
	GPIO_INPUT(GPIOC, 13);
	GPIO_SPEED_10M(GPIOC, 13);
	GPIO_FUNCTION(GPIOC, 13, 0x00);
	
	//PIN C 15 - SIM RESET
	GPIO_SET(GPIOC, 15);
	GPIO_INPUT(GPIOC, 15);
	GPIO_PUSHPULL(GPIOC, 15);
	GPIO_SPEED_10M(GPIOC, 15);
	GPIO_FUNCTION(GPIOC, 15, 0x00);
	
	//PIN C 14 - POWERDOWN
	GPIO_RESET(GPIOC, 14);
	GPIO_INPUT(GPIOC, 14);
	GPIO_PUSHPULL(GPIOC, 14);
	GPIO_SPEED_10M(GPIOC, 14);
	GPIO_FUNCTION(GPIOC, 14, 0x00);
	
	//PIN B 2 - DTR
	GPIO_SET(GPIOB, 2);
	GPIO_INPUT(GPIOB, 2);
	GPIO_PUSHPULL(GPIOB, 2);
	GPIO_SPEED_10M(GPIOB, 2);
	GPIO_FUNCTION(GPIOB, 2, 0x00);
}

void configure_interrupts(void)
{
	//Got values from misc.c
	//Priorities 0x700 to 0x300, Group_0 = 0x700 - no priority; Group_4 = 0x300 - all priority
	SCB->AIRCR = 0x05FA0000 | 0x300;
}

int main ( void )
{
	configure_interrupts();
	enable_gpio_clocks();
	init_gpio();
	
	init_usart();
	//init_adc();
	//init_timer();
	init_rtc();
	
	
	GPIO_OUTPUT(GPIOC, 14);
	delay_ms(4000);
	GPIO_INPUT(GPIOC, 14);
	delay_ms(3000);
	pc_putstring("Test");
	
	//reset_rn();
	
	//stop_timer();
	//start_timer();
	
	//stop_adc();
	//start_adc();
	//measure_battery();
	
	//if GPIO_READ(GPIOB, 8){
	//	pc_putstring("Reinited.\n");
	//	factory_reset_rn_module();
	//}else{
	//	pc_putstring("Didn't Reinit.\n");
	//	reset_rn();
	//}
	
	char c;
	while (1) {
		if(pc_filled()){
			c = pc_getchar();
			rn_putchar(c);
		}
		if(rn_filled()){
			c = rn_getchar();
			pc_putchar(c);
		}
	}
}

# ifdef USE_FULL_ASSERT
void assert_failed ( uint8_t * file , uint32_t line )
{
/* Infinite loop */
/* Use GDB to find out why we 're here */
while (1) ;
}
# endif