//Periph library
#include <stm32l1xx.h>

//Other files
#include "usart.h"
#include "cgpio.h"

__IO uint16_t* const usart3_sr = (uint16_t*)(USART3_BASE + 0x00);
__IO uint16_t* const usart3_dr = (uint16_t*)(USART3_BASE + 0x04);
__IO uint16_t* const usart3_brr = (uint16_t*)(USART3_BASE + 0x08);
__IO uint16_t* const usart3_cr1 = (uint16_t*)(USART3_BASE + 0x0c);
__IO uint16_t* const usart3_cr2 = (uint16_t*)(USART3_BASE + 0x10);
__IO uint16_t* const usart3_cr3 = (uint16_t*)(USART3_BASE + 0x14);

void enable_gpio_clocks(void)
{
	//enable clocks to ports
	RCC->AHBENR |= RCC_AHBENR_GPIOBEN;
	//RCC->AHBENR |= RCC_AHBENR_GPIOAEN;
}

void configure_interrupts(void)
{
	//Got values from misc.c
	//Priorities 0x700 to 0x300, Group_0 = 0x700 - no priority; Group_4 = 0x300 - all priority
	SCB->AIRCR = 0x05FA0000 | 0x300;
}

void setup_rn_module(void)
{

}

int main ( void )
{
	configure_interrupts();
	enable_gpio_clocks();
	
	init_usart();
	rn_putchar('U');
	rn_putstring("SART configured.");
	
	uint16_t test;
	test = *usart3_sr;
	test = *usart3_dr;
	test = *usart3_brr;
	
	if(test){
		test = test + 1;
	}
	
	while (1) {
	}
}

# ifdef USE_FULL_ASSERT
void assert_failed ( uint8_t * file , uint32_t line )
{
/* Infinite loop */
/* Use GDB to find out why we 're here */
while (1) ;
}
# endif