#include "usart.h"

char usart_rn_on = 0;

void init_usart(void)
{
	RCC->APB1ENR |= RCC_APB1ENR_USART3EN;
	//RCC->APB2ENR |= RCC_APB2ENR_USART1EN;
	 
	//U3 TX 10
	GPIO_ALTERNATE(GPIOB, 10);
	GPIO_PUSHPULL(GPIOB, 10);
	GPIO_SPEED_40M(GPIOB, 10);
	GPIO_FUNCTION(GPIOB, 10, 0x07);
	
	//U3 RX 11
	GPIO_ALTERNATE(GPIOB, 11);
	GPIO_PUSHPULL(GPIOB, 11);
	GPIO_SPEED_40M(GPIOB, 11);
	GPIO_FUNCTION(GPIOB, 11, 0x07);
	
	
	//USART3 - RN
	USART3->CR1 |= (USART_CR1_RE | USART_CR1_TE);
	//CR2 OK
	//CR3 OK
	USART3->BRR =0x0034; //38.4k
	
	USART3->CR1 |= USART_CR1_UE;
	usart_rn_on = 1;
	
}

void usart_rn_baud_rate_override(uint16_t val)
{
	USART3->CR1 &= ~USART_CR1_UE;
	USART3->BRR = val;
	USART3->CR1 |= USART_CR1_UE;
}

//Currently send is blocking, due to the fact that more probably isn't required
void rn_putchar(char c)
{
	assert_param(usart_rn_on);
	//while(USART_GetFlagStatus(USART1, USART_FLAG_TXE) == RESET);
	while(!(USART3->SR & USART_SR_TXE));
	USART3->DR = (c & 0xff);
}

void rn_putstring(char* s)
{
	while(*s != '\0'){
		rn_putchar(*(s++));
	}
}

